import { AppPage } from "./app.po";
import { ListPage } from "./list.po";
import { CalculatorPage } from "./calculator.po";

/**
 * Load a session containing 4 calculators, having multiple linked parameters
 * from one to another
 * @TODO les valeurs des Select sont comparées au français, pas très générique :/
 */
describe("ngHyd − load session with multiple linked parameters − ", () => {
  let startPage: AppPage;
  let listPage: ListPage;
  let calcPage: CalculatorPage;

  function init() {
      startPage = new AppPage();
      calcPage = new CalculatorPage();
      listPage = new ListPage();
  }
  beforeEach(init);

  it("when creating parallel structures, devices should be linkable to one another", async () => {

    // 1. check Lois d'ouvrages
    await startPage.navigateTo();
    await listPage.clickMenuEntryForCalcType(8);
    await calcPage.getAddStructureButton().click();
    const nb1 = await calcPage.getAllLinkButtons().count();
    expect(nb1).toBe(8); // link buttons on children but not on parent

    // 2. check Passe à bassin: Cloisons
    await startPage.navigateTo();
    await listPage.clickMenuEntryForCalcType(10);
    await calcPage.getAddStructureButton().click();
    const nb2 = await calcPage.getAllLinkButtons().count();
    expect(nb2).toBe(6); // link buttons on children but not on parent


    // 3. check Lois de déversoirs dénoyés
    await startPage.navigateTo();
    await listPage.clickMenuEntryForCalcType(9);
    await calcPage.getAddStructureButton().click();
    const nb3 = await calcPage.getAllLinkButtons().count();
    expect(nb3).toBe(6); // link buttons on children but not on parent

  });
});
