#! /bin/python3

# Combine tous les fichiers markdown de la documentation en un seul fichier
# Usage :
# python3 ./mkdocs-combine.py > cassiopee_doc-fr.md
# Pour la conversion au format tex :
# pandoc cassiopee_doc-fr.md -o cassiopee_doc-fr.md.tex

import yaml

sYAML = 'mkdocs.yml'

f = open(sYAML, 'r')
with f:
    try:
        dMkdocsYaml = yaml.load(f)
        bOK = True
    except yaml.YAMLError as e:
        print("YAML loading {}: {}".format(sYAML, str(e)))
print("YAML loaded {}".format(sYAML))

def explore(docs_dir, nav, output = ''):
    import os, re
    if type(nav) is str:
        nav = [nav]
    for d in nav:
        if type(d) is str:
            filepath = os.path.join(docs_dir,d)
            f = open(filepath, 'r')
            path = os.path.dirname(filepath)
            s = f.read() + "\n"
            s = re.sub(r'(\!\[.+\]\()(.+)(\))', r'\1'+path+r'/\2\3', s)
            s = re.sub(r'(\\\()(.+?)(\\\))', r'$\2$', s)
            output +=s

        elif type(d) is dict:
            for key, value in d.items():
                print(key)
                output = explore(docs_dir, value, output)
    return output

s = explore(dMkdocsYaml['docs_dir'], dMkdocsYaml['nav'])
print(s)
