import { SectionParametree, acSection, Result, ParamDefinition, Nub } from "jalhyd";

import { FormCompute } from "./form-compute";
import { FormDefSection } from "./form-def-section";
import { FormResultSection } from "./form-result-section";
import { VarResults } from "../../results/var-results";
import { SectionResults } from "../../results/section-results";
import { FormulaireDefinition } from "./form-definition";

export class FormComputeSectionParametree extends FormCompute {

    constructor(formBase: FormulaireDefinition, private _formSection: FormDefSection, formResult: FormResultSection) {
        super(formBase, formResult);
    }

    private get _formSectionResult(): FormResultSection {
        return this._formResult as FormResultSection;
    }

    private get _varResults(): VarResults {
        return this._formSectionResult.varResults;
    }

    private get _sectionResults(): SectionResults {
        return this._formSectionResult.sectionResults;
    }

    protected compute() {
        this.runNubCalc(this._formBase.currentNub);
        this.reaffectResultComponents();
    }

    protected runNubCalc(nub: Nub, computedParam?: ParamDefinition): Result {
        return nub.CalcSerie();
    }

    protected reaffectResultComponents() {
        const sectNub: SectionParametree = this._formBase.currentNub as SectionParametree;
        const sect: acSection = sectNub.section;
        this._sectionResults.section = sect;

        const varParams = this._formSection.getSectionVariatedParameters();
        if (varParams.length > 0) {
            // résultats variés avec tous les résultats complémentaires
            this._varResults.variatedParameters = varParams;
            this._varResults.result = sectNub.result;
            this._varResults.update(false);
        } else {
            // résultats de section (avec le graphique de section)
            this._sectionResults.result = sectNub.result;
            // résultats complémentaires des paramètres fixés
            this._formSectionResult.addSectionFixedParameters(false);
            this._formSectionResult.fixedResults.result = sectNub.result;
        }

    }
}
